package com.agileboot.domain.shop.order.query;

import cn.hutool.core.util.StrUtil;
import com.agileboot.common.core.page.AbstractPageQuery;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import java.util.Date;
import lombok.Data;
import lombok.EqualsAndHashCode;

@EqualsAndHashCode(callSuper = true)
@Data
public class SearchShopOrderQuery<T> extends AbstractPageQuery<T> {

    private String orderNumber;
    private Integer status;
    private Integer payStatus;
    private Date startTime;
    private Date endTime;

    @Override
    public QueryWrapper<T> addQueryCondition() {
        QueryWrapper<T> queryWrapper = new QueryWrapper<>();

        queryWrapper
            .like(StrUtil.isNotEmpty(orderNumber), "order_number", orderNumber)
            .eq(status != null, "status", status)
            .eq(payStatus != null, "pay_status", payStatus)
            .between(startTime != null && endTime != null, "create_time", startTime, endTime)
            .eq("deleted", 0)
            .orderByDesc("create_time");

        return queryWrapper;
    }
}