package com.agileboot.admin.controller.shop;

import com.agileboot.common.core.base.BaseController;
import com.agileboot.common.core.dto.ResponseDTO;
import com.agileboot.common.core.page.PageDTO;
import com.agileboot.domain.shop.order.OrderApplicationService;
import com.agileboot.domain.shop.order.db.ShopOrderEntity;
import com.agileboot.domain.shop.order.query.SearchShopOrderQuery;
import io.swagger.v3.oas.annotations.Operation;
import lombok.RequiredArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/shop/order")
@RequiredArgsConstructor
@Validated
public class ShopOrderController extends BaseController {
    private OrderApplicationService orderApplicationService;


    @Operation(summary = "订单列表")
//    @PreAuthorize("@permission.has('shop:goods:list')")
    @GetMapping("/list")
    public ResponseDTO<PageDTO<ShopOrderEntity>> list(SearchShopOrderQuery<ShopOrderEntity> query) {
        PageDTO<ShopOrderEntity> page = orderApplicationService.getOrderList(query);
        return ResponseDTO.ok(page);
    }
}
