package com.agileboot.domain.shop.order.db;

import com.agileboot.common.core.base.BaseEntity;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 商品订单表
 * </p>
 *
 * @author valarchie
 * @since 2025-03-10
 */
@Getter
@Setter
@TableName("shop_order")
@ApiModel(value = "ShopOrderEntity对象", description = "商品订单表")
public class ShopOrderEntity extends BaseEntity<ShopOrderEntity> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("订单唯一ID")
    @TableId(value = "order_id", type = IdType.AUTO)
    private Long orderId;

    @ApiModelProperty("ucid")
    @TableField("ucid")
    private String ucid;

    @ApiModelProperty("openid")
    @TableField("openid")
    private String openid;

    @ApiModelProperty("支付网关交易id")
    @TableField("trade_id")
    private String tradeId;

    @ApiModelProperty("手机号码")
    @TableField("mobile")
    private String mobile;

    @ApiModelProperty("企业微信用户ID或汇邦云用户ID")
    @TableField("userid")
    private String userid;

    @ApiModelProperty("用户姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty("是否内部用户（0否 1汇邦云用户 2企业微信用户）")
    @TableField("is_internal")
    private Integer isInternal;

    @ApiModelProperty("业务系统订单ID（对接外部系统）")
    @TableField("biz_order_id")
    private String bizOrderId;

    @ApiModelProperty("订单总金额")
    @TableField("total_amount")
    private BigDecimal totalAmount;

    @ApiModelProperty("订单状态（1待付款 2已付款 3已发货 4已完成 5已取消）")
    @TableField("`status`")
    private Integer status;

    @ApiModelProperty("支付状态（1未支付 2已支付 3退款中 4已退款）")
    @TableField("pay_status")
    private Integer payStatus;

    @ApiModelProperty("支付方式")
    @TableField("payment_method")
    private String paymentMethod;

    @ApiModelProperty("支付时间")
    @TableField("pay_time")
    private Date payTime;


    @Override
    public Serializable pkVal() {
        return this.orderId;
    }

}
